from datetime import date

class Jwan:
    persons = [
        {"ethel": {"birth_date": date(2004, 5, 4), "gender": "female", "fullname": "Ethel Densing"}},
        {"kylle": {"birth_date": date(2003, 11, 7), "gender": "male", "fullname": "Kylle Aliño"}},
        {"john marlie": {"birth_date": date(2004, 5, 23), "gender": "male", "fullname": "John Marlie Compas"}},
        {"emarie": {"birth_date": date(2004, 8, 16), "gender": "female", "fullname": "Emarie Tulod"}},
        {"josuan": {"birth_date": date(2004, 2, 21), "gender": "male", "fullname": "Josuan Leonardo Hulom"}}
    ]

    def __init__(self, gname: str = None):
        if gname is not None:
            self.display_person(gname.lower())
        self.congratulate_birthday()

    def congratulate_birthday(self):
        today = date.today()
        for person in self.persons:
            for name, info in person.items():
                age = today.year - info["birth_date"].year
                birthday_passed = today.month > info["birth_date"].month or (
                        today.month == info["birth_date"].month and today.day >= info["birth_date"].day
                )
                if birthday_passed and today.month == info["birth_date"].month and today.day == info["birth_date"].day:
                    print(f"Happy birthday, {name.capitalize()}! You are now {age} years old.")

    def display_person(self, name: str = None):
        if name is None:
            today = date.today()
            for person in self.persons:
                for name, info in person.items():
                    age = today.year - info["birth_date"].year
                    birthday_passed = today.month > info["birth_date"].month or (
                            today.month == info["birth_date"].month and today.day >= info["birth_date"].day
                    )
                    if birthday_passed:
                        if today.month == info["birth_date"].month and today.day == info["birth_date"].day:
                            age += 1
                            print(f"Happy birthday, {name.capitalize()}! They are now {age} years old.")
                        else:
                            print(f"{name.capitalize()} is now {age} years old.")
                    else:
                        print(f"{name.capitalize()} is {age - 1} years old.")
        else:
            found_person = False
            for person in self.persons:
                for person_name, info in person.items():
                    if person_name.lower() == name.lower():
                        age = date.today().year - info["birth_date"].year
                        self.recognize_fullname(name.lower())
                        print(f"is {age} years old and is {info['gender']}.")
                        found_person = True
                        break
            if not found_person:
                print("Person not found.")

    def display_name_by_birthday(self, birthday):
        for person in self.persons:
            for name, info in person.items():
                if info["birth_date"].month == birthday.month and info["birth_date"].day == birthday.day:
                    print(f"The person with the birthday {birthday} is {name.capitalize()}.")
                    return
        print("No person has a birthday on that date.")

    def recognize_gender_by_name(self, name):
        name = name.lower()
        for person in self.persons:
            for person_name, info in person.items():
                if name.lower() == person_name.lower():
                    print(f"{name.capitalize()}: is {info['gender'].capitalize()}")
                    return
        print("person not found.")

    def recognize_fullname(self, name: str = None):
        if name is not None:
            name = name.lower()
            for person in self.persons:
                if name in person:
                    getfullname = person[name]['fullname']
                    print(getfullname, end=' ')
                    return
            print(f"No person with the name '{name}' found.")
        else:
            for person in self.persons:
                for full in person.values():
                    print(full['fullname'])

    def my_first_method(self,*x):
        return sum(x)
